﻿Imports System.Linq
Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Navigation
Imports Microsoft.Phone.Controls
Imports Microsoft.Phone.Shell
Imports ContosoTransit.WP8App.Resources
Imports ContosoTransit.WP8App.Models
Imports Microsoft.Phone.Tasks
Imports Microsoft.Phone.Wallet
Imports System.Windows.Media.Imaging
Imports ContosoTransit.WP8Library

Namespace ContosoTransit.WP8App
	Partial Public Class MainPage
		Inherits PhoneApplicationPage
		Public Sub New()
			InitializeComponent()

            service = New MockTransitService

            addTask = New AddWalletItemTask
			AddHandler addTask.Completed, AddressOf task_Completed
		End Sub

		Private service As MockTransitService
		Private walletCard As WalletTransactionItem
		Private addTask As AddWalletItemTask

		Protected Overrides Sub OnNavigatedTo(ByVal e As NavigationEventArgs)
            Dim launchArgs As String = String.Empty
			If NavigationContext.QueryString.TryGetValue("ms_nfp_launchargs", launchArgs) Then
				If launchArgs.Contains("stationid=") Then
					Dim stationId As String = launchArgs.Substring(launchArgs.IndexOf("stationid=") + 10)

					NavigationService.Navigate(New Uri("/StationPage.xaml?checkin=true&stationid=" & stationId, UriKind.Relative))
					NavigationService.RemoveBackEntry()
				End If
			End If

			walletCard = TryCast(Wallet.FindItem("LoyaltyCard"), WalletTransactionItem)
			If walletCard IsNot Nothing Then
				balanceTxt.Text = walletCard.DisplayBalance
			End If

            Me.DataContext = service.GetStations
		End Sub

		Private Sub stationLst_SelectionChanged(ByVal sender As Object, ByVal e As SelectionChangedEventArgs)
			If stationLst.SelectedItem Is Nothing Then
                Exit Sub
			End If

			NavigationService.Navigate(New Uri("/StationPage.xaml?stationid=" & (TryCast(stationLst.SelectedItem, StationModel)).Id, UriKind.Relative))

			stationLst.SelectedItem = Nothing
		End Sub

		Private Sub Loyalty_MouseLeftButtonUp(ByVal sender As Object, ByVal e As System.Windows.Input.MouseButtonEventArgs)
			If walletCard Is Nothing Then
				AddCardToWallet()
			Else
				NavigationService.Navigate(New Uri("/CardPage.xaml", UriKind.Relative))
			End If
		End Sub

		Private Sub AddCardToWallet()
			Dim loyaltyCard As LoyaltyCardModel = service.GetLoyaltyCard("123456")

			Dim item As New WalletTransactionItem("LoyaltyCard")
			item.CustomerName = loyaltyCard.Name
			item.AccountNumber = loyaltyCard.UserId
			item.DisplayName = "Contoso Transit"
			item.IssuerName = "Contoso Transit"
			item.IssuerPhone.Business = "888-555-1212"
			item.IssuerWebsite = New Uri("http://microsoft.com")
			item.DisplayBalance = loyaltyCard.PointBalance & " points"

            Dim img As New BitmapImage
			Dim logoUri As New Uri("Assets/contoso_transit_logo.png", UriKind.Relative)
			img.SetSource(Application.GetResourceStream(logoUri).Stream)
			item.Logo99x99 = img
			item.Logo159x159 = img
			item.Logo336x336 = img

			item.NavigationUri = New Uri("/CardPage.xaml", UriKind.Relative)

			addTask.Item = item
			addTask.Show()
		End Sub

		Private Sub task_Completed(ByVal sender As Object, ByVal e As AddWalletItemResult)
			If e.TaskResult = TaskResult.OK Then
				walletCard = TryCast(e.Item, WalletTransactionItem)
				balanceTxt.Text = walletCard.DisplayBalance

				NavigationService.Navigate(New Uri("/CardPage.xaml", UriKind.Relative))
			End If

		End Sub

		Private Sub TagWriter_MouseLeftButtonUp(ByVal sender As Object, ByVal e As System.Windows.Input.MouseButtonEventArgs)
			NavigationService.Navigate(New Uri("/WriteTagPage.xaml", UriKind.Relative))
		End Sub

	End Class
End Namespace