﻿Imports System.Linq
Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Navigation
Imports Microsoft.Phone.Controls
Imports Microsoft.Phone.Shell
Imports ContosoTransit.WP8App.Models
Imports Windows.Networking.Proximity
Imports Windows.Storage.Streams
Imports NdefLibrary.Ndef
Imports System.Runtime.InteropServices.WindowsRuntime
Imports ContosoTransit.WP8Library

Namespace ContosoTransit.WP8App
	Partial Public Class WriteTagPage
		Inherits PhoneApplicationPage
		Public Sub New()
			InitializeComponent()

            device = ProximityDevice.GetDefault
            service = New MockTransitService
		End Sub

		Private service As MockTransitService
		Private device As ProximityDevice
		Private station As StationModel

		Protected Overrides Sub OnNavigatedTo(ByVal e As NavigationEventArgs)
            Me.DataContext = service.GetStations
		End Sub

		Private Sub writeBtn_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			station = TryCast(stationLst.SelectedItem, StationModel)
			If station IsNot Nothing Then
				If device IsNot Nothing Then
					writeBtn.Visibility = System.Windows.Visibility.Collapsed
					device.SubscribeForMessage("WriteableTag", AddressOf TagLocated)

					statusTxt.Text = "Tap tag you wish to write"
				Else
					MessageBox.Show("Unable to initialize NFC hardware")
				End If
			Else
				MessageBox.Show("Please select a station for the tag info")
			End If
		End Sub

		Private Sub TagLocated(ByVal sender As ProximityDevice, ByVal message As ProximityMessage)
			device.StopSubscribingForMessage(message.SubscriptionId)

            Dim appId As String = Windows.ApplicationModel.Store.CurrentApp.AppId.ToString
			Dim stationArgs As String = "stationid=" & station.Id

            Dim launchAppRecord As NdefLaunchAppRecord = New NdefLibrary.Ndef.NdefLaunchAppRecord
			launchAppRecord.Arguments = stationArgs
			launchAppRecord.AddPlatformAppId("WindowsPhone", "{" & appId & "}")

			Dim msg As NdefMessage = New NdefMessage From { launchAppRecord }

            device.PublishBinaryMessage("NDEF:WriteTag", msg.ToByteArray.AsBuffer, AddressOf TagWritten)

		End Sub

		Private Sub TagWritten(ByVal sender As ProximityDevice, ByVal messageId As Long)
			device.StopPublishingMessage(messageId)

			Dispatcher.BeginInvoke(Sub()
				MessageBox.Show("Tag written for " & station.Name)
				statusTxt.Text = ""
				writeBtn.Visibility = Visibility.Visible
			End Sub)
		End Sub

	End Class
End Namespace