﻿Imports System.Linq
Imports System.Text
Imports System.Threading.Tasks
Imports System.Collections.Generic

Namespace ContosoTransit.WP8Library
    Public Class MockTransitService
        Public Function GetStations() As List(Of StationModel)
            Return AllStations
        End Function

        Public Function GetLoyaltyCard(ByVal userId As String) As LoyaltyCardModel
            Dim card As LoyaltyCardModel = AllCards.Where(Function(c) c.UserId = userId).SingleOrDefault
            Return card
        End Function

        Public Function UpdatePointsOnCheckIn(ByVal userId As String, ByVal stationId As Integer) As Integer
            Dim card As LoyaltyCardModel = AllCards.Where(Function(c) c.UserId = userId).SingleOrDefault
            Dim balance As Integer = card.PointBalance
            Dim station As StationModel = AllStations.Where(Function(s) s.Id = stationId).SingleOrDefault
            If station IsNot Nothing Then
                card.StationsScanned.Add(Date.Now, station)

                balance += station.Points
            End If
            Return balance
        End Function

        Public Function GetDealForStationCheckIn(ByVal stationId As Integer) As DealModel
            Dim deal As DealModel = AllDeals.Where(Function(d) d.stationId = stationId).SingleOrDefault
            Return deal
        End Function

        Private Shared AllStations As New List(Of StationModel) From {
            New StationModel With {.Id = 1, .Name = "Main Street", .Message = "Next train 5 minutes", .Points = 100},
            New StationModel With {.Id = 2, .Name = "Virginia Avenue", .Message = "Next train 3 minutes", .Points = 200},
            New StationModel With {.Id = 3, .Name = "Tennessee Avenue", .Message = "Next train 10 minutes", .Points = 300},
            New StationModel With {.Id = 4, .Name = "Vermont Avenue", .Message = "Next train 2 minutes", .Points = 400},
            New StationModel With {.Id = 5, .Name = "Pennsylvania Avenue", .Message = "Next train 4 minutes", .Points = 500}}

        Private Shared AllCards As New List(Of LoyaltyCardModel) _
            From {
            New LoyaltyCardModel With {.UserId = "123456", .Name = "John Doe", .PointBalance = 100, .StationsScanned = New Dictionary(Of Date, StationModel) From {{Date.Now, AllStations(0)}}}}

        Private Shared AllDeals As New List(Of DealModel) From {
            New DealModel With {.stationId = 4, .Issuer = "Contoso Diner", .Name = "Free burger and fries", .Code = "ABC123", .LogoImagePath = "Assets/Contoso_diner_logo.png", .QRImagePath = "Assets/Contoso_diner_qr.png", .MerchantPhone = "888-555-2222", .DaysValid = 14},
            New DealModel With {.stationId = 5, .Issuer = "Contoso Transit", .Name = "Free ride for a day", .Code = "DEF456", .LogoImagePath = "Assets/Contoso_transit_logo.png", .QRImagePath = "Assets/Contoso_transit_qr.png", .MerchantPhone = "888-555-1212", .DaysValid = 30}}
    End Class
End Namespace
