﻿Imports System.Windows
Imports Microsoft.Phone.Scheduler
Imports ContosoTransit.WP8Library
Imports Microsoft.Phone.Wallet
Imports System.Diagnostics

Namespace ContosoTransit.WP8WalletAgent
    Public Class ContosoTransitWalletAgent
        Inherits WalletAgent
        ''' <remarks>
        ''' ScheduledAgent constructor, initializes the UnhandledException handler
        ''' </remarks>
        Shared Sub New()
            ' Subscribe to the managed exception handler
            Deployment.Current.Dispatcher.BeginInvoke(Sub() AddHandler Application.Current.UnhandledException, AddressOf UnhandledException)
        End Sub

        ''' Code to execute on Unhandled Exceptions
        Private Shared Sub UnhandledException(ByVal sender As Object, ByVal e As ApplicationUnhandledExceptionEventArgs)
            If Debugger.IsAttached Then
                ' An unhandled exception has occurred; break into the debugger
                Debugger.Break()
            End If
        End Sub

        ''' <summary>
        ''' Agent that runs a scheduled task
        ''' </summary>
        ''' <param name="task">
        ''' The invoked task
        ''' </param>
        ''' <remarks>
        ''' This method is called when a periodic or resource intensive task is invoked
        ''' </remarks>
        Protected Overrides Async Sub OnRefreshData(ByVal args As RefreshDataEventArgs)
            Dim Service As New MockTransitService

            For Each item As WalletItem In args.Items
                Dim walletCard As WalletTransactionItem = TryCast(item, WalletTransactionItem)
                If walletCard IsNot Nothing Then
                    Dim loyaltyCard As LoyaltyCardModel = Service.GetLoyaltyCard(walletCard.AccountNumber)
                    If loyaltyCard IsNot Nothing Then
                        For Each scan In loyaltyCard.StationsScanned.Keys
                            If Not walletCard.TransactionHistory.ContainsKey(scan.ToString) Then
                                Dim station As StationModel = loyaltyCard.StationsScanned(scan)
                                Dim Txn As New WalletTransaction
                                Txn.TransactionDate = Date.Now
                                Txn.Description = station.Name
                                Txn.DisplayAmount = station.Points & " points"
                                walletCard.TransactionHistory.Add(Date.Now.ToString, Txn)
                            End If
                        Next scan
                    End If
                    Await walletCard.SaveAsync
                End If
            Next item
            NotifyComplete()
        End Sub
    End Class
End Namespace